mod Ex07b logic: 'cl'

incl Mtex

incl Mtexg

incl Mtexln

incl Mauxb

loc rem 
  \para \bf  7. CVICENIE Z PREDMETU 1-AIN-470 SPECIFIKACIA A VERIFIKACIA 
  PROGRAMOV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.19 
  \para* \it  Datum:  \end stvrtok 26.3.2009 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-470-svp/0809ls/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane parovacej funkcii 
  a zoznamom. Zadanie sa sklada z tychto suborov: 
  \items 
   \item \para Subory \it  mtex*.cl  \end obsahuju makra pre CL-TeX. 
   \item \para Subory \it  maux*.cl  \end obsahuju definicie a vlastnosti 
         pomocnych funkcii a predikatov. 
   \item \para Subory \it  ex*.cl  \end obsahuju ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  [CL] Remark.  \end The module \it  Msyntax  \end in the file \it  
  msyntax.cl  \end contains the syntax of the system CL. 

rem 
  \para \bf  [CL] Remark.  \end The module \it  Mlogicq  \end in the file \it  
  mlogicq.cl  \end contains the syntax of quantifier tableau rules. The module 
  \it  Mlogicd  \end in the file \it  mlogicd.cl  \end contains the syntax of 
  derived tableau rules. The module \it  Mlogicpa  \end in the file \it  
  mlogicpa.cl  \end contains the syntax of arithmetic tableau rules and built-in 
  properties of the pre-defined functions and predicates in the system CL. 

rem 
  \para \bf  Chapter. Programs Operating on Lists.  \end 

rem 
  \para \bf  Section. Lists.  \end 

rem 
  \para \bf  [CL] Structural case analysis on lists.  \end Syntax: 
  \eq* 
    'case Ln ; <term>'
  \end
  \para Example(s): 
  \items 
   \item \para \ft Tex_f1_g_x_case Tex_f2_g_x_sc(Ln,t) \end 
         \eq* 
           Tex_f2_g_x_nrule(Tex_f0_g_x_nothing,
                            Tex_f2_g_x_branch(Tex_f1_g_x_assum Tex_f2_g_eq(t,0),
                                              Tex_f1_g_x_assum Tex_f2_g_eq(t,v,w)))
         \end
         \para where \ft v \end and \ft w \end are new variables \it  
         (eigen-variables)  \end. 
  \end
  \para The predicate \ft Ln \end is defined in the module \it  Standard  \end. 

rem 
  \para \bf  [CL] Structural induction on lists.  \end 
  \header* fun R 'Tex2_g_appl_phi_sb' \end Syntax: 
  \eq* 
    'ind Ln ; <variable> [; <variable(s)>]'
  \end
  \para where the induction formula is formed from the current sequent. 
  \para Example(s): 
  \items 
   \item \para \ft Tex_f1_g_x_ind Tex_f2_g_x_sc(Ln,x) \end 
         \eq* 
           Tex_f2_g_x_nrule(Tex_f1_g_x_goal R(x),
                            Tex_f2_g_x_branch(Tex_f1_g_x_goal R(0),
                                              Tex_f1_g_x_goal Tex_f2_g_imp(R(w),
                                                                           R(v,w))))
         \end
   \item \para \ft Tex_f1_g_x_ind Tex_f2_g_x_sc(Tex_f2_g_x_sc(Ln,x),a) \end 
         \eq* 
           Tex_f2_g_x_nrule(Tex_f1_g_x_goal R(x),
                            Tex_f2_g_x_branch(Tex_f1_g_x_goal R(0),
                                              Tex_f1_g_x_goal Tex_f2_g_imp(Tex_f2_g_forall(a,
                                                                                           R(w)),
                                                                           R(v,w))))
         \end
  \end
  \para The predicate \ft Ln \end is defined in the module \it  Standard  \end. 

rem 
  \para \bf  List length.  \end 

fun L 
  L(0) = 0
  L(v,w) = L(w)+1

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    L(x) = 0 <-> x = 0
  \end
  \eq* 
    \e x L(x) = n
  \end

thm L_is_zero
  L(x) = 0 <-> x = 0

thm L_surjective
  \e x L(x) = n

rem 
  \para \bf  Exercise.  \end Show that 
  \def 
    fun L 
    L(x) = \m n [ Iproj2(n,x) = 0 ]
  \end
  \para by proving 
  \eq* 
    Iproj2(L(x),x) = 0
  \end
  \eq* 
    n < L(x) -> Iproj2(n,x) != 0
  \end

thm L_by_minimalization1
  Iproj2(L(x),x) = 0

thm L_by_minimalization2
  n < L(x) -> Iproj2(n,x) != 0

rem 
  \para \bf  List indexing.  \end 

fun/2 Sub 'Tex_f2_ln_sub'
  Sub((v,w),0) = v
  Sub((v,w),i+1) = Sub(w,i)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    Sub(x,0) = Proj1(x)
  \end
  \eq* 
    Sub(x,i+1) = Sub(Proj2(x),i)
  \end
  \para \it  Hint.  \end By structural case analysis on the list \ft x \end. 

thm Sub_zero
  Sub(x,0) = Proj1(x)

thm Sub_succ
  Sub(x,i+1) = Sub(Proj2(x),i)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    Sub(x,i) = Proj1 Iproj2(i,x)
  \end

thm Sub_expl
  Sub(x,i) = Proj1 Iproj2(i,x)

rem 
  \para \bf  List concatenation.  \end 

fun/2 Conc 'Tex_f2_ln_conc'
  Conc(0,y) = y
  Conc((v,w),y) = v,Conc(w,y)

rem 
  \para \bf  Remark.  \end We write \ft Conc(Conc(x,y),z) \end as an 
  abbreviation for \ft Tex_f2_ln_conc_nassoc(Tex_f2_ln_conc_nassoc(x,y),z) \end. 

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    Conc(x,y) = 0 <-> x = 0 & y = 0
  \end
  \eq* 
    Conc(x,0) = x
  \end
  \eq* 
    Conc(x,Conc(y,z)) = Conc(Conc(x,y),z)
  \end
  \eq* 
    Conc(x,y) = Conc(x,z) -> y = z
  \end
  \eq* 
    Conc(x,a,0) = Conc(y,b,0) -> x = y & a = b
  \end
  \eq* 
    Conc(x,z) = Conc(y,z) -> x = y
  \end

thm Conc_is_zero
  Conc(x,y) = 0 <-> x = 0 & y = 0

thm Conc_zero_right
  Conc(x,0) = x

thm Conc_assoc
  Conc(x,Conc(y,z)) = Conc(Conc(x,y),z)

thm Conc_cancel_left
  Conc(x,y) = Conc(x,z) -> y = z

thm Conc_cancel_last
  Conc(x,a,0) = Conc(y,b,0) -> x = y & a = b

thm Conc_cancel_right
  Conc(x,z) = Conc(y,z) -> x = y

rem 
  \para \bf  [CL] Remark.  \end The list concatenation function \ft x++y \end, 
  written as \it  x++y  \end, is defined in the module \ft Standard \end and the 
  following properties are built in into the CL theorem prover: 
  \eq* 
    0++y = y
  \end
  \eq* 
    (v,w)++y = v,w++y
  \end
  \eq* 
    x++y = 0 <-> x = 0 & y = 0
  \end
  \eq* 
    x++0 = x
  \end
  \eq* 
    x++(y++z) = x++y++z
  \end
  \eq* 
    x++y = x++z <-> y = z
  \end
  \eq* 
    x++(a,0) = y++(b,0) <-> x = y & a = b
  \end
  \eq* 
    x++z = y++z <-> x = y
  \end
  \eq* 
    x++y = a,0 -> x = a,0 & y = 0 \/ x = 0 & y = a,0
  \end
  \eq* 
    x++(a,y) = a,0 <-> x = 0 & y = 0
  \end
  \eq* 
    x++a++y = a,0 <-> a = 0 & x++y = 0,0
  \end
  \para From now on we will be using the built-in version of the list 
  concatenation function. 

rem 
  \para \bf  Exercise.  \end 
  \eq* 
    L(x++y) = L(x)+L(y)
  \end
  \eq* 
    i < L(x) -> Sub(x++y,i) = Sub(x,i)
  \end
  \eq* 
    i < L(y) -> Sub(x++y,L(x)+i) = Sub(y,i)
  \end
  \eq* 
    x != 0 <-> \e y\e a x = y++(a,0)
  \end

thm Conc_l
  L(x++y) = L(x)+L(y)

thm Conc_sub_left
  i < L(x) -> Sub(x++y,i) = Sub(x,i)

thm Conc_sub_right
  i < L(y) -> Sub(x++y,L(x)+i) = Sub(y,i)

thm Conc_nzero
  x != 0 <-> \e y\e a x = y++(a,0)

rem 
  \para \bf  List membership.  \end 

pred/2 In1 'Tex_p2_ln_in'
  In1(x,v,w) <- x = v
  In1(x,v,w) <- x != v & In1(x,w)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    In1(x,v,w) <-> x = v \/ In1(x,w)
  \end
  \eq* 
    In1(x,y++z) <-> In1(x,y) \/ In1(x,z)
  \end

thm In_pair
  In1(x,v,w) <-> x = v \/ In1(x,w)

thm In_conc
  In1(x,y++z) <-> In1(x,y) \/ In1(x,z)

rem 
  \para \bf  [CL] Remark.  \end The list membership predicate \ft x in y \end 
  written as \it  x in y  \end, is defined in the module \ft Standard \end. The 
  following properties are built in into the CL theorem prover: 
  \eq* 
    x in 0 <-> \f
  \end
  \eq* 
    x in v,w <-> x = v \/ x in w
  \end
  \eq* 
    x in y++z <-> x in y \/ x in z
  \end
  \para From now on we will be using the built-in version of the list membership 
  predicate. 
  \para Note that the negation \ft x !in y \end is written as \it  x !in y 
   \end. 

rem 
  \para \bf  List reversal.  \end 

fun Rev 
  Rev(0) = 0
  Rev(v,w) = Rev(w)++(v,0)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    Rev(x) = 0 <-> x = 0
  \end
  \eq* 
    Rev(x++y) = Rev(y)++Rev(x)
  \end
  \eq* 
    Rev Rev(x) = x
  \end
  \eq* 
    Rev(x) = Rev(y) -> x = y
  \end
  \eq* 
    \e y Rev(y) = x
  \end
  \eq* 
    x in Rev(y) <-> x in y
  \end
  \eq* 
    L Rev(x) = L(x)
  \end

thm Rev_is_zero
  Rev(x) = 0 <-> x = 0

thm Rev_conc
  Rev(x++y) = Rev(y)++Rev(x)

thm Rev_rev
  Rev Rev(x) = x

thm Rev_injective
  Rev(x) = Rev(y) -> x = y

thm Rev_surjective
  \e y Rev(y) = x

thm Rev_in
  x in Rev(y) <-> x in y

thm Rev_l
  L Rev(x) = L(x)

rem 
  \para \bf  Fast list reversal.  \end 

fun/2 Reva 'Tex_f2_f'
  Reva(0,a) = a
  Reva((v,w),a) = Reva(w,v,a)

rem 
  \para Prove 
  \eq* 
    Rev(x) = Reva(x,0)
  \end

thm Rev_by_reva
  Rev(x) = Reva(x,0)

